<?php
/**
 * @project Astra.CMS
 * @link http://a-cms.ru/
 * @copyright 2011 "Астра Вебтехнологии"
 * @author Vitaly Hohlov <admin@a-cms.ru>
 * @package Modules
 */
/**************************************************************************/

class ForumModule_Admin extends A_MainFrame
{
  function __construct()
  {
    parent::__construct("module_forum.tpl");

    $this->AddJScript("/modules/forum/admin/forum.js");
  }

  function Action($action)
  {
    $res=false;
    switch($action)
    { case "addcat": $res=$this->AddCat(); break;
	  case "editcat": $res=$this->EditCat(); break;
	  case "delcat": $res=$this->DelCat(); break;
	  case "up": $res=$this->Up(); break;
	  case "down": $res=$this->Down(); break;
      case "addtop": $res=$this->AddTopic(); break;
	  case "edittop": $res=$this->EditTopic(); break;
	  case "deltop": $res=$this->DelTopic(); break;
	  case "movetop": $res=$this->MoveTopics(); break;
	  case "setsorttop": $res=$this->setSortTopic(); break;
	  case "setrowstop": $res=$this->setRowsTopic(); break;
	  case "setfiltertop": $res=$this->setFilterTopic(); break;
	  case "unfiltertop": $res=$this->unFilterTopic(); break;
	  case "setactivetop": $res=$this->SetActiveTopic(); break;
	  case "setunactivetop": $res=$this->SetUnActiveTopic(); break;
	  case "deletetop": $res=$this->DeleteTopic(); break;
	  case "addmes": $res=$this->AddMessage(); break;
	  case "editmes": $res=$this->EditMessage(); break;
	  case "delmes": $res=$this->DelMessage(); break;
	  case "setsortmes": $res=$this->setSortMessage(); break;
	  case "setrowsmes": $res=$this->setRowsMessage(); break;
	  case "setfiltermes": $res=$this->setFilterMessage(); break;
	  case "unfiltermes": $res=$this->unFilterMessage(); break;
	  case "deletemes": $res=$this->DeleteMessage(); break;
	}
    if($res)
	A::goUrl("admin.php?mode=sections&item=".ITEM,array('idcat','idtop','tab','page','page1'));
  }

  function AddCat()
  {
	$_REQUEST['name']=strip_tags($_REQUEST['name']);
	$_REQUEST['idker']=(integer)$_REQUEST['idker'];
	$_REQUEST['urlname']=getURLName($_REQUEST['name'],$_REQUEST['urlname'],SECTION."_categories");
    $_REQUEST['sort']=A::$DB->getOne("SELECT MAX(sort) FROM ".SECTION."_categories WHERE idker=".(integer)$_REQUEST['idker'])+1;

    $dataset = new A_DataSet(SECTION."_categories");
    $dataset->fields=array("idker","name","urlname","sort");
	if($_REQUEST['idker'])
	{ $_REQUEST['level']=A::$DB->getOne("SELECT level FROM ".SECTION."_categories WHERE id=".(integer)$_REQUEST['idker'])+1;
	  $dataset->fields[]="level";
	  $dataset->fields[]="description";
	}
    return $dataset->Insert();
  }

  function EditCat()
  {
	$_REQUEST['name']=strip_tags($_REQUEST['name']);
	$_REQUEST['idker']=(integer)$_REQUEST['idker'];
	$_REQUEST['urlname']=getURLName($_REQUEST['name'],$_REQUEST['urlname'],SECTION."_categories","id<>".(integer)$_REQUEST['id']);

    $dataset = new A_DataSet(SECTION."_categories");
    $dataset->fields=array("idker","name","urlname");
	if($_REQUEST['idker'])
	$dataset->fields[]="description";
    return $dataset->Update();
  }

  function DelCatBranch($id)
  {
    $subs=A::$DB->getCol("SELECT id FROM ".SECTION."_categories WHERE idker=$id");
    foreach($subs as $subid)
    $this->DelCatBranch($subid);

	if($row=A::$DB->getRowById($id,SECTION."_categories"))
    { $files=A::$DB->getCol("SELECT idfile FROM ".SECTION."_messages WHERE idcat=$id AND idfile>0");
	  foreach($files as $idfile)
	  DelRegFile($idfile);

	  A::$DB->execute("DELETE FROM ".SECTION."_categories WHERE id=$id");
	  A::$DB->execute("DELETE FROM ".SECTION."_messages WHERE idcat=$id");
	  A::$DB->execute("DELETE FROM ".SECTION."_topics WHERE idcat=$id");
	}
	return true;
  }

  function DelCat()
  {
    return $this->DelCatBranch((integer)$_REQUEST['id']);
  }

  function Up()
  {
	if($row=A::$DB->getRowById($_REQUEST['id'],SECTION."_categories"))
	{ $nextrow=A::$DB->getRow("SELECT id,sort FROM ".SECTION."_categories WHERE idker={$row['idker']} AND sort<{$row['sort']} ORDER BY sort DESC LIMIT 0,1");
	  A::$DB->execute("UPDATE ".SECTION."_categories SET sort={$row['sort']} WHERE id={$nextrow['id']}");
	  A::$DB->execute("UPDATE ".SECTION."_categories SET sort={$nextrow['sort']} WHERE id={$row['id']}");
	  return true;
	}
	return false;
  }

  function Down()
  {
    if($row=A::$DB->getRowById($_REQUEST['id'],SECTION."_categories"))
	{ $prevrow=A::$DB->getRow("SELECT id,sort FROM ".SECTION."_categories WHERE idker={$row['idker']} AND sort>{$row['sort']} ORDER BY sort LIMIT 0,1");
	  A::$DB->execute("UPDATE ".SECTION."_categories SET sort={$row['sort']} WHERE id={$prevrow['id']}");
	  A::$DB->execute("UPDATE ".SECTION."_categories SET sort={$prevrow['sort']} WHERE id={$row['id']}");
	  return true;
	}
	return false;
  }

  function setFilterTopic()
  {
    $filter=array();
    $filter['active']=true;
    $filter['name']=A::$DB->real_escape_string($_REQUEST['name']);
	$filter['date']=isset($_REQUEST['date']);
	$filter['date1']=(integer)$_REQUEST['from'];
	$filter['date2']=(integer)$_REQUEST['to'];
	$filter['status']=A::$DB->real_escape_string($_REQUEST['status']);
	A_Session::set(SECTION."_topic_filter",$filter);
	return true;
  }

  function unFilterTopic()
  {
    $filter=array("active"=>false,"name"=>"","date"=>false,"status"=>0);
  	$date1=A::$DB->getOne("SELECT MIN(date) FROM ".SECTION."_topics");
	$filter['date1']=$date1>0?$date1:time();
	$filter['date2']=time();
	A_Session::set(SECTION."_topic_filter",$filter);
    return true;
  }

  function setSortTopic()
  {
    A_Session::set(SECTION."_topic_sort",$_REQUEST['sort']);
	setcookie(SECTION."_topic_sort",$_REQUEST['sort'],time()+31104000);
	return true;
  }

  function setRowsTopic()
  {
    A_Session::set(SECTION."_topic_rows",$_REQUEST['rows']);
	setcookie(SECTION."_topic_rows",$_REQUEST['rows'],time()+31104000);
	return true;
  }

  function SetActiveTopic()
  {
    if(isset($_REQUEST['checktop']))
	foreach($_REQUEST['checktop'] as $id)
	A::$DB->execute("UPDATE ".SECTION."_topics SET active='Y' WHERE id=".(integer)$id);
	return true;
  }

  function SetUnActiveTopic()
  {
    if(isset($_REQUEST['checktop']))
	foreach($_REQUEST['checktop'] as $id)
	A::$DB->execute("UPDATE ".SECTION."_topics SET active='N' WHERE id=".(integer)$id);
	return true;
  }

  function DeleteTopic()
  {
    if(isset($_REQUEST['checktop']))
	foreach($_REQUEST['checktop'] as $id)
	$this->DelTopic($id);
	return true;
  }

  function AddTopic()
  {
	$_REQUEST['name']=strip_tags($_REQUEST['name']);
	$_REQUEST['active']=isset($_REQUEST['active'])?"Y":"N";
	$_REQUEST['message']=parse_bbcode($_REQUEST['bbcode']);
	$_REQUEST['content']=str_replace("&nbsp;"," ",strip_tags($_REQUEST['message']));

    $dataset = new A_DataSet(SECTION."_topics");
    $dataset->fields=array("date","idcat","idowner","name","content","active");

    if($id=$dataset->Insert())
	{
	  $_REQUEST['idtop']=$id;

      $dataset = new A_DataSet(SECTION."_messages");
      $dataset->fields=array("date","idcat","idtop","idowner","bbcode","message");

      if($idmes=$dataset->Insert())
	  { if($idfile=UploadFile("mesfile",$_REQUEST['name'],0,$idmes))
	    A::$DB->execute("UPDATE ".SECTION."_messages SET idfile=$idfile WHERE id=$idmes");
	  }

      $category=A::$DB->getOne("SELECT name FROM ".SECTION."_categories WHERE id=".(integer)$_REQUEST['idcat']);
      $name=$category.' - '.$_REQUEST['name'];
	  A::$OBSERVER->Event('searchIndexUpdate',SECTION,array('id'=>$id,'name'=>$name,'content'=>$_REQUEST['content']));

	  return true;
	}
	else
	return false;
  }

  function EditTopic()
  {
	$_REQUEST['name']=strip_tags($_REQUEST['name']);
	$_REQUEST['active']=isset($_REQUEST['active'])?"Y":"N";

    $dataset = new A_DataSet(SECTION."_topics");
    $dataset->fields=array("date","idcat","idowner","name","active");

    if($row=$dataset->Update())
	{ if($row['idcat']!=$_REQUEST['idcat'])
	  A::$DB->Update(SECTION."_messages",array('idcat'=>(integer)$_REQUEST['idcat']),"idtop=".$row['id']);

      $category=A::$DB->getOne("SELECT name FROM ".SECTION."_categories WHERE id=".(integer)$_REQUEST['idcat']);
      $name=$category.' - '.$_REQUEST['name'];
	  A::$OBSERVER->Event('searchIndexUpdate',SECTION,array('id'=>$row['id'],'name'=>$name,'content'=>$row['content']));

	  if(!empty($_POST['idcat']))
	  unset($_POST['idcat']);

	  return true;
	}
	else
	return false;
  }

  function DelTopic($id=0)
  {
	if($id>0)
	$_REQUEST['id']=$id;

    $dataset = new A_DataSet(SECTION."_topics");
    if($row=$dataset->Delete())
	{
	  $files=A::$DB->getCol("SELECT idfile FROM ".SECTION."_messages WHERE idtop=".$row['id']." AND idfile>0");
	  foreach($files as $idfile)
	  DelRegFile($idfile);

	  A::$DB->execute("DELETE FROM ".SECTION."_messages WHERE idtop=".$row['id']);

	  A::$OBSERVER->Event('searchIndexDelete',SECTION,array('id'=>$row['id']));
	}
	else
	return false;
  }

  function MoveTopics()
  {
	if(!isset($_REQUEST['checktop'])) return false;
	$idto=(integer)$_REQUEST['idto'];
	foreach($_REQUEST['checktop'] as $id)
	if($data=A::$DB->getRowById($id,SECTION."_topics"))
	{ if($data['idcat']==$idto) continue;

	  A::$DB->Update(SECTION."_topics",array('idcat'=>$idto),"id=".(integer)$id);
	  A::$DB->Update(SECTION."_messages",array('idcat'=>$idto),"idtop=".(integer)$id);

	  $category=A::$DB->getOne("SELECT name FROM ".SECTION."_categories WHERE id=".$idto);
      $name=$category.' - '.$data['name'];
	  A::$OBSERVER->Event('searchIndexUpdate',SECTION,array('id'=>$data['id'],'name'=>$name,'content'=>$data['content']));
	}
	return true;
  }

  function getFilterTopic()
  {
    $filter=A_Session::get(SECTION."_topic_filter",array());
	$where="";
	if($filter['active'])
	{ if(!empty($filter['name']))
	  $where.="t.name LIKE '%".$filter['name']."%'";
	  if($filter['date'])
	  { $where.=!empty($where)?" AND ":"";
	    $where.="t.date>=".$filter['date1'];
	    $where.=" AND t.date<=".$filter['date2'];
	  }
	  if(!empty($filter['status']))
	  { $where.=!empty($where)?" AND ":"";
	    $where.="t.active='".$filter['status']."'";
	  }
	}
    return $where;
  }

  function setFilterMessage()
  {
	$filter=array();
    $filter['active']=true;
	$filter['content']=A::$DB->real_escape_string($_REQUEST['content']);
	$filter['date']=isset($_REQUEST['date']);
	$filter['date1']=(integer)$_REQUEST['from'];
	$filter['date2']=(integer)$_REQUEST['to'];
	A_Session::set(SECTION."_mess_filter",$filter);
	return true;
  }

  function unFilterMessage()
  {
	$filter=array("active"=>false,"content"=>"","date"=>false);
  	$date1=A::$DB->getOne("SELECT MIN(date) FROM ".SECTION."_messages");
	$filter['date1']=$date1>0?$date1:time();
	$filter['date2']=time();
	A_Session::set(SECTION."_mess_filter",$filter);
    return true;
  }

  function setSortMessage()
  {
    A_Session::set(SECTION."_mess_sort",$_REQUEST['sort']);
	setcookie(SECTION."_mess_sort",$_REQUEST['sort'],time()+31104000);
	return true;
  }

  function setRowsMessage()
  {
    A_Session::set(SECTION."_mess_rows",(integer)$_REQUEST['rows']);
	setcookie(SECTION."_mess_rows",(integer)$_REQUEST['rows'],time()+31104000);
	return true;
  }

  function DeleteMessage()
  {
    if(isset($_REQUEST['checkmes']))
	foreach($_REQUEST['checkmes'] as $id)
	$this->DelMessage($id);
	return true;
  }

  function AddMessage()
  {
	$_REQUEST['message']=parse_bbcode($_REQUEST['bbcode']);

    $dataset = new A_DataSet(SECTION."_messages");
    $dataset->fields=array("date","idcat","idtop","idowner","bbcode","message");

    if($id=$dataset->Insert())
	{
	  if($idfile=UploadFile("mesfile","",0,$id))
	  A::$DB->execute("UPDATE ".SECTION."_messages SET idfile=$idfile WHERE id=$id");

	  if($topic=A::$DB->getRowById($_REQUEST['idtop'],SECTION."_topics"))
	  { $content=$topic['content']."\n".str_replace("&nbsp;"," ",strip_tags($_REQUEST['message']));
	    A::$DB->Update(SECTION."_topics",array('content'=>$content),"id=".$topic['id']);
	    $category=A::$DB->getOne("SELECT name FROM ".SECTION."_categories WHERE id=".$topic['idcat']);
        $name=$category.' - '.$topic['name'];
	    A::$OBSERVER->Event('searchIndexUpdate',SECTION,array('id'=>$topic['id'],'name'=>$name,'content'=>$content));
      }

	  return true;
	}
	else
	return false;
  }

  function EditMessage()
  {
	$_REQUEST['message']=parse_bbcode($_REQUEST['bbcode']);

    $dataset = new A_DataSet(SECTION."_messages");
    $dataset->fields=array("date","idowner","bbcode","message");

    if($row=$dataset->Update())
	{
	  if($idfile=UploadFile("mesfile","",$row['idfile'],$row['id']))
	  A::$DB->execute("UPDATE ".SECTION."_messages SET idfile=$idfile WHERE id=".$row['id']);
	  if(isset($_REQUEST['filedel']))
	  { DelRegFile($row['idfile']);
	    A::$DB->execute("UPDATE ".SECTION."_messages SET idfile=0 WHERE id=".$row['id']);
	  }

	  if($topic=A::$DB->getRowById($row['idtop'],SECTION."_topics"))
	  { $messages=A::$DB->getCol("SELECT message FROM ".SECTION."_messages WHERE idtop=".$topic['id']);
	    $content=str_replace("&nbsp;"," ",strip_tags(implode("\n",$messages)));
		A::$DB->Update(SECTION."_topics",array('content'=>$content),"id=".$topic['id']);
	    $category=A::$DB->getOne("SELECT name FROM ".SECTION."_categories WHERE id=".$topic['idcat']);
        $name=$category.' - '.$topic['name'];
	    A::$OBSERVER->Event('searchIndexUpdate',SECTION,array('id'=>$topic['id'],'name'=>$name,'content'=>$content));
      }

	  return true;
	}
	else
	return false;
  }

  function DelMessage($id=0)
  {
    if($id>0)
	$_REQUEST['id']=$id;

    $dataset = new A_DataSet(SECTION."_messages");
    if($row=$dataset->Delete())
	{ DelRegFile($row['idfile']);

	  if($topic=A::$DB->getRowById($row['idtop'],SECTION."_topics"))
	  { $messages=A::$DB->getCol("SELECT message FROM ".SECTION."_messages WHERE idtop=".$topic['id']);
	    $content=str_replace("&nbsp;"," ",strip_tags(implode("\n",$messages)));
		A::$DB->Update(SECTION."_topics",array('content'=>$content),"id=".$topic['id']);
	    $category=A::$DB->getOne("SELECT name FROM ".SECTION."_categories WHERE id=".$topic['idcat']);
        $name=$category.' - '.$topic['name'];
	    A::$OBSERVER->Event('searchIndexUpdate',SECTION,array('id'=>$topic['id'],'name'=>$name,'content'=>$content));
      }

	  return true;
	}
	else
	return false;
  }

  function getFilterMessage()
  {
    $filter=A_Session::get(SECTION."_mess_filter",array());
	$where="";
	if($filter['active'])
	{ if(!empty($filter['name']))
	  $where.="name LIKE '%".$filter['name']."%'";
	  if(!empty($filter['content']))
	  { $where.=!empty($where)?" AND ":"";
	    $where.="message LIKE '%".$filter['content']."%'";
	  }
	  if($filter['date'])
	  { $where.=!empty($where)?" AND ":"";
	    $where.="date>=".$filter['date1'];
	    $where.=" AND date<=".$filter['date2'];
	  }
	}
    return $where;
  }

  function getPager($idtop,$rowsmes,$link)
  {
    $pager="";
	$rcount=A::$DB->getOne("SELECT COUNT(*) FROM ".SECTION."_messages WHERE idtop=$idtop");
	$pages=ceil($rcount/$rowsmes);
	if($pages>1)
    { for($i=0;$i<$pages;$i++)
	  if($i==0)
	  $pager.="<a href=\"$link\">".($i+1)."</a>&nbsp;";
	  elseif($i<10)
	  $pager.="<a href=\"$link&page1=$i\">".($i+1)."</a>&nbsp;";
	  else
	  break;
	  if($pages>10)
	  { if($pages>11)
	    $pager.="...&nbsp;";
	    $i=$pages-1;
	    $pager.="<a href=\"$link&page1=$i\">".($i+1)."</a>";
	  }
	}
	return $pager;
  }

  function createData()
  {
	$usection=getSectionByModule('users');

	$this->Assign("userssection",$usection);

	if(empty($usection)) return;

	$minsort=A::$DB->getOne("SELECT MIN(sort) FROM ".SECTION."_categories WHERE idker=0");
	$maxsort=A::$DB->getOne("SELECT MAX(sort) FROM ".SECTION."_categories WHERE idker=0");

	$rowsmes=(integer)A_Session::get(SECTION."_mess_rows",isset($_COOKIE[SECTION.'_mess_rows'])?$_COOKIE[SECTION.'_mess_rows']:10);

	$categories=$_categories=array();
    A::$DB->query("SELECT * FROM ".SECTION."_categories WHERE idker=0 ORDER BY sort");
    while($row=A::$DB->fetchRow())
    { $row['bsort']="";
	  if($row['sort']>$minsort)
	  $row['bsort'].=AddImageButtonLink("/templates/admin/images/up.gif","admin.php?mode=sections&item=".ITEM."&authcode=".A::$AUTH->authcode."&action=up&id=".$row['id'],"Выше",16,16);
	  if($row['sort']<$maxsort)
	  $row['bsort'].=AddImageButtonLink("/templates/admin/images/down.gif","admin.php?mode=sections&item=".ITEM."&authcode=".A::$AUTH->authcode."&action=down&id=".$row['id'],"Ниже",16,16);
	  $minsort2=A::$DB->getOne("SELECT MIN(sort) FROM ".SECTION."_categories WHERE idker=".$row['id']);
	  $maxsort2=A::$DB->getOne("SELECT MAX(sort) FROM ".SECTION."_categories WHERE idker=".$row['id']);
	  $row['subcategories']=array();
      A::$DB->query("SELECT * FROM ".SECTION."_categories WHERE idker=".$row['id']." ORDER BY sort");
	  while($row2=A::$DB->fetchRow())
	  { $row2['link']="admin.php?mode=sections&item=".ITEM."&idcat=".$row2['id']."&tab=category";
	    $row2['browse']=forum_createCategoryLink($row2['id'],SECTION);
	    $row2['topics']=A::$DB->getOne("SELECT COUNT(*) FROM ".SECTION."_topics WHERE idcat=".$row2['id']);
		$row2['messages']=A::$DB->getOne("SELECT COUNT(*) FROM ".SECTION."_messages WHERE idcat=".$row2['id']);
		if($row2['lastmess']=A::$DB->getRow("
		SELECT m.*,t.name AS topic FROM ".SECTION."_messages AS m
		LEFT JOIN ".SECTION."_topics AS t ON t.id=m.idtop
		WHERE m.idcat=".$row2['id']."
		ORDER BY m.date DESC LIMIT 0,1"))
		{ $tm=A::$DB->getOne("SELECT COUNT(*) FROM ".SECTION."_messages WHERE idtop=".$row2['lastmess']['idtop']);
		  $row2['lastmess']['link']="admin.php?mode=sections&item=".ITEM."&idcat=".$row2['lastmess']['idcat']."&idtop=".$row2['lastmess']['idtop']."&tab=topic";
		  if($tm>$rowsmes)
		  $row2['lastmess']['link'].="&page1=".floor($tm/$rowsmes);
		  $row2['lastmess']['owner']=A::$DB->getRowById($row2['lastmess']['idowner'],$usection);
		}
	    $row2['bsort']="";
	    if($row2['sort']>$minsort2)
	    $row2['bsort'].=AddImageButtonLink("/templates/admin/images/up.gif","admin.php?mode=sections&item=".ITEM."&authcode=".A::$AUTH->authcode."&action=up&id=".$row2['id'],"Выше",16,16);
	    if($row2['sort']<$maxsort2)
	    $row2['bsort'].=AddImageButtonLink("/templates/admin/images/down.gif","admin.php?mode=sections&item=".ITEM."&authcode=".A::$AUTH->authcode."&action=down&id=".$row2['id'],"Ниже",16,16);
	    $row['subcategories'][]=$row2;
	    $_categories[$row2['id']]=$row['name']." » ".$row2['name'];
	  }
	  A::$DB->free();
	  $categories[]=$row;
    }
    A::$DB->free();

	$this->Assign("categories",$categories);
	$this->Assign("_categories",$_categories);

    if(!empty($_GET['idcat']))
	{
	  $idcat=(integer)$_GET['idcat'];

	  if(!A_Session::is_set(SECTION."_topic_filter"))
      $this->unFilterTopic();

      if($category=A::$DB->getRowById($idcat,SECTION."_categories"))
	  { $this->Assign("category",$category);
	    $this->AddJVar("cur_idcat",$idcat);

	    $where=$this->getFilterTopic();

	    $rows=(integer)A_Session::get(SECTION."_topic_rows",isset($_COOKIE[SECTION.'_topic_rows'])?$_COOKIE[SECTION.'_topic_rows']:20);
	    $sort=escape_order_string(A_Session::get(SECTION."_topic_sort",isset($_COOKIE[SECTION.'_topic_sort'])?$_COOKIE[SECTION.'_topic_sort']:"lastdate DESC"));

	    $topics=array();
	    $pager = new A_Pager($rows);
        $pager->query("
	    SELECT t.*,MAX(m.date) AS lastdate
		FROM ".SECTION."_topics AS t
		LEFT JOIN ".SECTION."_messages AS m ON m.idtop=t.id
	    WHERE t.idcat=$idcat".(!empty($where)?" AND $where":"")."
	    GROUP BY m.idtop
	    ORDER BY $sort");
        while($row=$pager->fetchRow())
        { $row['link']="admin.php?mode=sections&item=".ITEM."&idcat=$idcat&idtop=".$row['id']."&tab=topic".(!empty($_GET['page'])?"&page=".$_GET['page']:"");
          $row['pager']=$this->getPager($row['id'],$rowsmes,$row['link']);
	      $row['browse']=forum_createItemLink($row['id'],SECTION);
		  $row['messages']=A::$DB->getOne("SELECT COUNT(*) FROM ".SECTION."_messages WHERE idtop=".$row['id']);
	      $row['owner']=A::$DB->getRowById($row['idowner'],$usection);
	      if($row['lastmess']=A::$DB->getRow("SELECT * FROM ".SECTION."_messages WHERE idtop=".$row['id']." ORDER BY date DESC LIMIT 0,1"))
	      $row['lastmess']['owner']=A::$DB->getRowById($row['lastmess']['idowner'],$usection);
	      $topics[]=$row;
        }
        $pager->free();

	    $this->Assign("topics",$topics);
	    $this->Assign("topics_pager",$pager);

	    $this->Assign("sorttop",$sort);
	    $this->Assign("rowstop",$rows);
	    $this->Assign("filtertop",!empty($where));
	  }
    }

    if(!empty($category) && !empty($_GET['idtop']))
	{
	  $idtop=(integer)$_GET['idtop'];

      if(!A_Session::is_set(SECTION."_mess_filter"))
      $this->unFilterMessage();

      if($topic=A::$DB->getRowById($idtop,SECTION."_topics"))
	  { $this->Assign("topic",$topic);
	    $this->AddJVar("cur_idtop",$idtop);

	    $where=$this->getFilterMessage();

	    $rows=$rowsmes;
        $sort=escape_order_string(A_Session::get(SECTION."_mess_sort",isset($_COOKIE[SECTION.'_mess_sort'])?$_COOKIE[SECTION.'_mess_sort']:"date"));

	    $messages=array();
	    $pager = new A_Pager($rows);
        $pager->query("
	    SELECT * FROM ".SECTION."_messages
	    WHERE idtop=$idtop".(!empty($where)?" AND $where":"")."
	    ORDER BY $sort");
        while($row=$pager->fetchRow())
        { $row['owner']=A::$DB->getRowById($row['idowner'],$usection);
	      $row['owner']['mcount']=A::$DB->getOne("SELECT COUNT(*) FROM ".SECTION."_messages WHERE idowner=".$row['idowner']);
	      $messages[]=$row;
        }
        $pager->free();

	    $this->Assign("messages",$messages);
	    $this->Assign("messages_pager",$pager);

	    if($pager->pages>0)
	    $this->AddJVar("last_page",$pager->pages);

	    $this->Assign("sortmes",$sort);
	    $this->Assign("rowsmes",$rows);
	    $this->Assign("filtermes",!empty($where));
	  }
    }

    $this->Assign("optbox1",new A_OptionsBox("Внешний вид на сайте:",array("idgroup"=>1)));
	$this->Assign("optbox2",new A_OptionsBox("Администратор:",array("idgroup"=>2)));
	$this->Assign("optbox3",new A_OptionsBox("Уведомления:",array("idgroup"=>3)));
	$this->Assign("optbox4",new A_OptionsBox("Дополнительно:",array("idgroup"=>4)));
  }
}

A::$MAINFRAME = new ForumModule_Admin;