<?php
/**
 * @project Astra.CMS
 * @link http://a-cms.ru/
 * @copyright 2011 "Астра Вебтехнологии"
 * @author Vitaly Hohlov <admin@a-cms.ru>
 * @package Modules
 */
/**************************************************************************/

class ForumModule_Request extends A_Request
{
  function Action($action)
  {
    switch($action)
    { case "getaddcatform": $this->getAddCatForm(); break;
	  case "geteditcatform": $this->getEditCatForm(); break;
	  case "getaddtopform": $this->getAddTopicForm(); break;
	  case "getedittopform": $this->getEditTopicForm(); break;
	  case "getfiltertopform": $this->getFilterTopicForm(); break;
	  case "getmovetopform": $this->getMoveTopicForm(); break;
	  case "getaddmesform": $this->getAddMessageForm(); break;
	  case "geteditmesform": $this->getEditMessageForm(); break;
	  case "getquoteform": $this->getQuoteForm(); break;
	  case "getfiltermesform": $this->getFilterMessageForm(); break;
	  case "setsort": $this->setSort(); break;
    }
  }

  function getAddCatForm()
  {
    $form = new A_Form("module_forum_addcat.tpl");
	$form->data['idker']=$_POST['idker'];
	$this->RESULT['title']=$form->data['idker']==0?"Новый раздел форума":"Новая категория форума";
	$this->RESULT['html'] = $form->getContent();
  }

  function getEditCatForm()
  {
    $form = new A_Form("module_forum_editcat.tpl");
	$form->data=A::$DB->getRowById($_POST['id'],SECTION."_categories");
	$form->data['categories']=A::$DB->getAssoc("SELECT id,name FROM ".SECTION."_categories WHERE idker=0 ORDER BY sort");
	$this->RESULT['title']=$form->data['idker']==0?"Редактор раздела форума":"Редактор категории форума";
	$this->RESULT['html'] = $form->getContent();
  }

  function getAddTopicForm()
  {
    $form = new A_Form("module_forum_addtop.tpl");
	$form->data['idcat']=$_POST['idcat'];
	$form->data['idowner']=A::$OPTIONS['idadmin'];
	$this->RESULT['html'] = $form->getContent();
  }

  function getEditTopicForm()
  {
    $form = new A_Form("module_forum_edittop.tpl");
	$form->data=A::$DB->getRowById($_POST['id'],SECTION."_topics");
	$form->data['categories']=A::$DB->getAssoc("SELECT id,name FROM ".SECTION."_categories WHERE level=1 ORDER BY sort");
	$this->RESULT['html'] = $form->getContent();
  }

  function getFilterTopicForm()
  {
    $filter=A_Session::get(SECTION."_topic_filter",array());
	$form = new A_Form("module_forum_filtertop.tpl");
	$form->data['idcat']=$_POST['idcat'];
	$form->data['name']=$filter['name'];
	$form->data['date']=$filter['date'];
	$form->data['from']=$filter['date1'];
	$form->data['to']=$filter['date2'];
	$form->data['statuss']=array(0=>"Не выбрано","Y"=>"Открытые","N"=>"Закрытые");
	$form->data['status']=$filter['status'];
	$frame = new A_Frame("default_form.tpl","Фильтр тем",$form);
	$this->RESULT['html'] = $frame->getContent();
  }

  function getMoveTopicForm()
  {
    if(empty($_POST['items'])) return;
    $form = new A_Form("module_forum_movetop.tpl");
	$form->data['idcat']=(integer)$_POST['idcat'];
	$form->data['items']=array_values($_POST['items']);
	$form->data['categories']=A::$DB->getAssoc("SELECT id,name FROM ".SECTION."_categories WHERE level=1 AND id<>{$form->data['idcat']} ORDER BY sort");
	if(count($form->data['categories'])>0)
	$this->RESULT['html']=$form->getContent();
	else
	$this->RESULT['html']=AddLabel("Нет вариантов перемещения.");
  }

  function getAddMessageForm()
  {
    $form = new A_Form("module_forum_addmes.tpl");
	$form->data['idcat']=$_POST['idcat'];
	$form->data['idtop']=$_POST['idtop'];
	$form->data['idowner']=A::$OPTIONS['idadmin'];
	$this->RESULT['html'] = $form->getContent();
  }

  function getEditMessageForm()
  {
    $form = new A_Form("module_forum_editmes.tpl");
	$form->data=A::$DB->getRowById($_POST['id'],SECTION."_messages");
	$this->RESULT['html'] = $form->getContent();
  }

  function getQuoteForm()
  {
    $form = new A_Form("module_forum_addmes.tpl");
    $usection=getSectionByModule('users');
	$mrow=A::$DB->getRowById($_POST['id'],SECTION."_messages");
	if(!empty($mrow))
	{ $mrow['owner']=A::$DB->getRowById($mrow['idowner'],$usection);
	  if(!empty($mrow['owner']))
	  $form->data['message']="[quote=\"{$mrow['owner']['name']}\"]{$mrow['bbcode']}[/quote]\n";
	}
	$form->data['idcat']=$mrow['idcat'];
	$form->data['idtop']=$mrow['idtop'];
	$form->data['idowner']=A::$OPTIONS['idadmin'];
	$this->RESULT['html'] = $form->getContent();
  }

  function getFilterMessageForm()
  {
    $filter=A_Session::get(SECTION."_mess_filter",array());
	$form = new A_Form("module_forum_filtermes.tpl");
	$form->data['idcat']=$_POST['idcat'];
	$form->data['idtop']=$_POST['idtop'];
	$form->data['content']=$filter['content'];
	$form->data['date']=$filter['date'];
	$form->data['from']=$filter['date1'];
	$form->data['to']=$filter['date2'];
	$frame = new A_Frame("default_form.tpl","Фильтр сообщений",$form);
	$this->RESULT['html'] = $frame->getContent();
  }

  function setSort()
  {
    $sort=!empty($_POST['sort'])?explode(",",$_POST['sort']):array();
	$i=1;
	foreach($sort as $id)
	A::$DB->Update(SECTION."_categories",array('sort'=>$i++),"id=".(integer)$id);
  }
}

A::$REQUEST = new ForumModule_Request;