<?php
/**
 * @project Astra.CMS
 * @link http://a-cms.ru/
 * @copyright 2011 " "
 * @author Vitaly Hohlov <admin@a-cms.ru>
 * @package Modules
 */
/**************************************************************************/

class ForumModule extends A_MainFrame
{
  public $idcat=0;
  public $category;
  public $idtop=0;
  public $topic;

  function Router($uri)
  {
	foreach($uri as $param)
	if(preg_match("/([^.]+)\.html$/",$param,$matches))
    { if($matches[1]=="addtopic")
	  { $this->page="addtopic";
	    return;
	  }
	  if($this->topic=A::$DB->getRow("SELECT * FROM ".SECTION."_topics WHERE idcat={$this->idcat} AND id=".(integer)$matches[1]))
	  $this->idtop=$this->topic['id'];
	  else
	  A::NotFound();
	  break;
    }
	elseif($this->category=A::$DB->getRow("SELECT * FROM ".SECTION."_categories WHERE urlname='$param'"))
    { $this->idcat=$this->category['id'];
	  if($this->category['level']>0)
	  { if(!getAccess("readall"))
	    { if(!getAccess("cat{$this->idcat}_read"))
	      { $this->goAccessDenied();
	        return;
	      }
		}
	  }
    }
    else
    A::NotFound();

	if($this->idtop>0)
	$this->page="topic";
	elseif($this->idcat>0)
	$this->page="category";
	else
	$this->page="main";
  }

  function Action($action)
  {
    if(A::$AUTH->isLoginCode())
	switch($action)
	{ case "addtopic": $this->AddTopic(); break;
	  case "addmessage": $this->AddMessage(); break;
	  case "editmessage": $this->EditMessage(); break;
	  case "delmessage": $this->DelMessage(); break;
	  case "quote": $this->Quote(); break;
	  case "closetopic": $this->CloseTopic(); break;
	  case "deltopic": $this->DelTopic(); break;
	  case "tomail": $this->ToMail(); break;
	  case "cancel": $this->Cancel(); break;
	}
  }

  function AddTopic()
  {
	if(!$this->category) return false;

	$newclosetopic = getAccess("newclosetopic") || getAccess("cat{$this->idcat}_newclosetopic");
	$moderation = getAccess("moderation",SECTION,false) || getAccess("cat{$this->idcat}_moderation",SECTION,false);
	$usefiles = A::$OPTIONS['usefiles']?$moderation || getAccess("download"):false;

	if(!$newclosetopic && !$moderation)
	return false;

    $_REQUEST['date']=time();
	$_REQUEST['active']='Y';
	$_REQUEST['idowner']=A::$AUTH->id;
	$_REQUEST['idcat']=$this->idcat;
	$_REQUEST['name']=strip_tags($_REQUEST['name']);
	$_REQUEST['usersmail']=isset($_REQUEST['tomail'])?serialize(array(A::$AUTH->id)):"";
	$_REQUEST['message'] = parse_bbcode($_REQUEST['bbcode']);
	$_REQUEST['content']=str_replace("&nbsp;"," ",strip_tags($_REQUEST['message']));

	if(empty($_REQUEST['name']) || empty($_REQUEST['message'])) return false;

    $dataset = new A_DataSet(SECTION."_topics");
    $dataset->fields=array("date","idcat","idowner","name","content","usersmail","active");

    if($id=$dataset->Insert())
	{
	  $link=forum_createItemLink($id,SECTION);

	  $_REQUEST['idtop']=$id;

      $dataset = new A_DataSet(SECTION."_messages");
      $dataset->fields=array("date","idcat","idtop","idowner","bbcode","message");

	  if($idmess=$dataset->Insert())
	  { if($usefiles)
        { if($idfile=UploadFile("attach",$_REQUEST['name'],0,$idmess))
	      A::$DB->execute("UPDATE ".SECTION."_messages SET idfile=$idfile WHERE id=$idmess");
	    }
      }

      $name=$this->category['name'].' - '.$_REQUEST['name'];
	  A::$OBSERVER->Event('searchIndexUpdate',SECTION,array('id'=>$id,'name'=>$name,'content'=>$_REQUEST['content']));

      if(A::$OPTIONS['email'] && A::$OPTIONS['newtopictpl'])
	  { $mail = new A_Mail(A::$OPTIONS['newtopictpl'],"html");
	    $topic=array();
		$topic['owner']=A::$AUTH->data['name'];
	    $topic['date']=time();
	    $topic['name']=$_REQUEST['name'];
	    $topic['link']='http://'.HOSTNAME.$link;
		$topic['message']=$_REQUEST['message'];
	    $mail->Assign("topic",$topic);
	    $mail->send(A::$OPTIONS['email']);
	  }

	  A::goUrl($link);
	}
	else
	return false;
  }

  function AddMessage()
  {
	if(!$this->topic) return false;

	$newmessage = getAccess("newmessage") || getAccess("cat{$this->idcat}_newmessage");
	$moderation = getAccess("moderation",SECTION,false) || getAccess("cat{$this->idcat}_moderation",SECTION,false);
	$usefiles = A::$OPTIONS['usefiles']?$moderation || getAccess("download"):false;

	if(!$newmessage && !$moderation)
	return false;

	$_REQUEST['message'] = parse_bbcode($_REQUEST['bbcode']);
	$_REQUEST['date']=time();
	$_REQUEST['idcat']=$this->idcat;
	$_REQUEST['idtop']=$this->idtop;
	$_REQUEST['idowner']=A::$AUTH->id;

	if(empty($_REQUEST['message'])) return false;

	if(!$moderation && $this->topic['active']!='Y') return false;

	$dataset = new A_DataSet(SECTION."_messages");

	if(empty($_REQUEST['id']))
	{
	  $rcount=A::$DB->getOne("SELECT COUNT(*) FROM ".SECTION."_messages WHERE idtop=$this->idtop")+1;
	  $pages = A::$OPTIONS['rowsmes']>0?ceil($rcount/A::$OPTIONS['rowsmes']):1;
	  if($pages>1)
      $this->topic['link']=forum_createItemLink($this->idtop,SECTION)."?page=".($pages-1);
	  else
	  $this->topic['link']=forum_createItemLink($this->idtop,SECTION);

	  $dataset->fields=array("date","idcat","idtop","idowner","bbcode","message");
	  if($idmess=$dataset->Insert())
	  {
	    if($usefiles)
        { if($idfile=UploadFile("attach",$this->topic['name'],0,$idmess))
	      A::$DB->execute("UPDATE ".SECTION."_messages SET idfile=$idfile WHERE id=$idmess");
	    }

	    $content=$this->topic['content']."\n".str_replace("&nbsp;"," ",strip_tags($_REQUEST['message']));
	    A::$DB->Update(SECTION."_topics",array('content'=>$content),"id=".$this->idtop);
        $name=$this->category['name'].' - '.$this->topic['name'];
	    A::$OBSERVER->Event('searchIndexUpdate',SECTION,array('id'=>$this->idtop,'name'=>$name,'content'=>$content));

	    if(A::$OPTIONS['newmessagetpl'])
	    { $message=array();
		  $message['owner']=A::$AUTH->data['name'];
	      $message['date']=time();
	      $message['message']=$_REQUEST['message'];
	      $topic=$this->topic;
	      $topic['link']='http://'.HOSTNAME.$topic['link'];
		  $usersmail=!empty($this->topic['usersmail'])?unserialize($this->topic['usersmail']):array();
	      foreach($usersmail as $id)
	      if($id!=A::$AUTH->id)
	      { if($user=A::$DB->getRowById($id,A::$AUTH->section))
	        { $mail = new A_Mail(A::$OPTIONS['newmessagetpl'],"html");
	          $mail->Assign("message",$message);
	          $mail->Assign("topic",$topic);
			  $mail->Assign("user",$user);
 		      $mail->send("{$user['name']}<{$user['email']}>");
		    }
	      }
	    }
	  }
	}
	elseif($mrow=A::$DB->getRowById((integer)$_REQUEST['id'],SECTION."_messages"))
	{
	  if(!empty($_GET['page']))
      $this->topic['link']=forum_createItemLink($this->idtop,SECTION)."?page=".$_GET['page'];
	  else
	  $this->topic['link']=forum_createItemLink($this->idtop,SECTION);

	  if(empty($mrow) || (!$moderation && $mrow['idowner']!=A::$AUTH->id))
	  return false;
	  else
	  { $lastpost=A::$DB->getOne("
	    SELECT MAX(date)
	    FROM ".SECTION."_messages
	    WHERE idtop=".$mrow['idtop']);
	    if(!$moderation && $mrow['date']!=$lastpost)
		return false;
	    $dataset->fields=array("bbcode","message");
		if($moderation)
		{ $_REQUEST['mdate']=time();
		  $dataset->fields[]="mdate";
		}
		else
		{ $_REQUEST['edate']=time();
		  $dataset->fields[]="edate";
		}
	    if($row=$dataset->Update())
		{ if($usefiles)
          { if($idfile=UploadFile("attach",$this->topic['name'],$row['idfile'],$row['id']))
	        A::$DB->execute("UPDATE ".SECTION."_messages SET idfile=$idfile WHERE id=".$row['id']);
	      }

	      $messages=A::$DB->getCol("SELECT message FROM ".SECTION."_messages WHERE idtop=".$this->idtop);
	      $content=str_replace("&nbsp;"," ",strip_tags(implode("\n",$messages)));
		  A::$DB->Update(SECTION."_topics",array('content'=>$content),"id=".$this->idtop);
          $name=$this->category['name'].' - '.$this->topic['name'];
	      A::$OBSERVER->Event('searchIndexUpdate',SECTION,array('id'=>$this->idtop,'name'=>$name,'content'=>$content));
		}
	  }
	}
	else
	return false;

    $usersmail=!empty($this->topic['usersmail'])?unserialize($this->topic['usersmail']):array();

	if(isset($_REQUEST['tomail']) && !in_array(A::$AUTH->id,$usersmail))
	$usersmail[]=A::$AUTH->id;
	elseif(!isset($_REQUEST['tomail']) && in_array(A::$AUTH->id,$usersmail))
	{ $key=array_search(A::$AUTH->id,$usersmail);
	  unset($usersmail[$key]);
	}

	A::$DB->Update(SECTION."_topics",array('usersmail'=>serialize($usersmail)),"id=".$this->idtop);

    A::goUrl($this->topic['link']);
  }

  function Quote()
  {
	if(empty($_REQUEST['id']) || !$this->topic) return false;

	$newmessage = getAccess("newmessage") || getAccess("cat{$this->idcat}_newmessage");
	if(!$newmessage)
	$moderation = getAccess("moderation",SECTION,false) || getAccess("cat{$this->idcat}_moderation",SECTION,false);
	if(!$newmessage && !$moderation)
	return false;

	$mrow=A::$DB->getRowById($_REQUEST['id'],SECTION."_messages");
	if($mrow && $mrow['idcat']==$this->idcat)
	{ $mrow['owner']=A::$DB->getRowById($mrow['idowner'],A::$AUTH->section);
	  if(!empty($mrow['owner']))
	  $_REQUEST['bbcode']="[quote=\"{$mrow['owner']['name']}\"]{$mrow['bbcode']}[/quote]\n";
	}
	else
	return false;
  }

  function EditMessage()
  {
	if(empty($_REQUEST['id']) || !$this->topic) return false;

	$newmessage = getAccess("newmessage") || getAccess("cat{$this->idcat}_newmessage");
	$moderation = getAccess("moderation",SECTION,false) || getAccess("cat{$this->idcat}_moderation",SECTION,false);
	if(!$newmessage && !$moderation)
	return false;

	if(!$moderation && $this->topic['active']!='Y') return false;

	$mrow=A::$DB->getRowById($_REQUEST['id'],SECTION."_messages");
	if($mrow && $mrow['idcat']==$this->idcat)
	{ if(!$moderation && $mrow['idowner']!=A::$AUTH->id)
	  return false;
	  $_REQUEST['bbcode']=$mrow['bbcode'];
	  $_REQUEST['idedit']=$mrow['id'];
	  $_REQUEST['owner']=A::$DB->getRowById($mrow['idowner'],A::$AUTH->section);
	  $_REQUEST['owner']['mcount']=A::$DB->getOne("SELECT COUNT(*) FROM ".SECTION."_messages WHERE idowner=".$mrow['idowner']);
	  $_REQUEST['date']=$mrow['date'];
	  $_REQUEST['idedit']=$_REQUEST['id'];
	}
  }

  function DelMessage()
  {
	if(empty($_REQUEST['id']) || !$this->topic) return false;

	$newmessage = getAccess("newmessage") || getAccess("cat{$this->idcat}_newmessage");
	$moderation = getAccess("moderation",SECTION,false) || getAccess("cat{$this->idcat}_moderation",SECTION,false);
	if(!$newmessage && !$moderation)
	return false;

	if(!$moderation && $this->topic['active']!='Y') return false;

	if($mrow=A::$DB->getRowById($_REQUEST['id'],SECTION."_messages"))
	{ if(!$moderation && $mrow['idowner']!=A::$AUTH->id)
	  return false;
	  $lastpost=A::$DB->getOne("SELECT MAX(date) FROM ".SECTION."_messages WHERE idtop=".$mrow['idtop']);
	  $countpost=A::$DB->getOne("SELECT COUNT(*) FROM ".SECTION."_messages WHERE idtop=".$mrow['idtop']);
	  if(!$moderation && ($mrow['date']!=$lastpost || $countpost<2))
	  return false;
	  A::$DB->execute("DELETE FROM ".SECTION."_messages WHERE id=".$mrow['id']);
	  DelRegFile($mrow['idfile']);

	  $messages=A::$DB->getCol("SELECT message FROM ".SECTION."_messages WHERE idtop=".$this->idtop);
	  $content=str_replace("&nbsp;"," ",strip_tags(implode("\n",$messages)));
	  A::$DB->Update(SECTION."_topics",array('content'=>$content),"id=".$this->idtop);
      $name=$this->category['name'].' - '.$this->topic['name'];
	  A::$OBSERVER->Event('searchIndexUpdate',SECTION,array('id'=>$this->idtop,'name'=>$name,'content'=>$content));

      A::goUrl(forum_createItemLink($this->idtop,SECTION,array('page')));
	}
	else
	return false;
  }

  function CloseTopic()
  {
    if(empty($_REQUEST['id']) || !$this->category) return false;

	$newclosetopic = getAccess("newclosetopic") || getAccess("cat{$this->idcat}_newclosetopic");
	$moderation = getAccess("moderation",SECTION,false) || getAccess("cat{$this->idcat}_moderation",SECTION,false);
	if(!$newclosetopic && !$moderation)
	return false;

	if($trow=A::$DB->getRowById($_REQUEST['id'],SECTION."_topics"))
	{ if(!$moderation && $trow['idowner']!=A::$AUTH->id)
	  return false;

	  A::$DB->execute("UPDATE ".SECTION."_topics SET active='N' WHERE id=".$trow['id']);

	  A::goUrl(forum_createCategoryLink($this->idcat,SECTION),array('page'));
	}
	else
	return false;
  }

  function DelTopic()
  {
	if(empty($_REQUEST['id']) || !$this->category) return false;

	if(!getAccess("moderation",SECTION,false))
	{ if(!getAccess("cat{$this->idcat}_moderation",SECTION,false))
	  return false;
	}

	if($trow=A::$DB->getRowById((integer)$_REQUEST['id'],SECTION."_topics"))
	{
	  A::$DB->execute("DELETE FROM ".SECTION."_topics WHERE id=".$trow['id']);

	  $files=A::$DB->getCol("SELECT idfile FROM ".SECTION."_messages WHERE idtop=".$trow['id']." AND idfile>0");
	  foreach($files as $idfile)
	  DelRegFile($idfile);
	  A::$DB->execute("DELETE FROM ".SECTION."_messages WHERE idtop=".$trow['id']);

	  A::$OBSERVER->Event('searchIndexDelete',SECTION,array('id'=>$trow['id']));

	  A::goUrl(forum_createCategoryLink($this->idcat,SECTION),array('page'));
	}
	else
	return false;
  }

  function ToMail()
  {
	if(!$this->topic) return false;

	if(!getAccess("newmessage"))
	{ if(!getAccess("cat{$this->idcat}_newmessage"))
	  return false;
	}

	$usersmail=!empty($this->topic['usersmail'])?unserialize($this->topic['usersmail']):array();

	if(in_array(A::$AUTH->id,$usersmail))
	unset($usersmail[array_search(A::$AUTH->id,$usersmail)]);
	else
	$usersmail[]=A::$AUTH->id;

	A::$DB->Update(SECTION."_topics",array('usersmail'=>serialize($usersmail)),"id=".$this->idtop);

	A::goUrl(forum_createItemLink($this->idtop,SECTION),array('page'));
  }

  function Cancel()
  {
	if(!$this->topic) return false;

	A::goUrl(forum_createItemLink($this->idtop,SECTION),array('page'));
  }

  function createData()
  {
	switch($this->page)
	{ case "main": $this->MainPage(); break;
	  case "category": $this->CategoryPage(); break;
	  case "topic": $this->TopicPage(); break;
	  case "addtopic": $this->AddTopicPage(); break;
	}

	$this->Assign("registerlink",getSectionLink(A::$AUTH->section)."register.html");
  }

  function MainPage()
  {
	$categories=array();
    A::$DB->query("SELECT * FROM ".SECTION."_categories WHERE idker=0 ORDER BY sort");
    while($row=A::$DB->fetchRow())
	{ $row['subcategories']=array();
      A::$DB->query("SELECT * FROM ".SECTION."_categories WHERE idker=".$row['id']." ORDER BY sort");
	  while($row2=A::$DB->fetchRow())
	  { $row2['link']=getSectionLink(SECTION).$row2['urlname']."/";
	    $row2['topics']=A::$DB->getOne("SELECT COUNT(*) FROM ".SECTION."_topics WHERE idcat=".$row2['id']);
		$row2['messages']=A::$DB->getOne("SELECT COUNT(*) FROM ".SECTION."_messages WHERE idcat=".$row2['id']);
		if($row2['lastmess']=A::$DB->getRow("
		SELECT m.*,t.name AS topic FROM ".SECTION."_messages AS m
		LEFT JOIN ".SECTION."_topics AS t ON t.id=m.idtop
		WHERE m.idcat=".$row2['id']."
		ORDER BY m.date DESC LIMIT 0,1"))
		{ $tm=A::$DB->getOne("SELECT COUNT(*) FROM ".SECTION."_messages WHERE idtop=".$row2['lastmess']['idtop']);
		  $row2['lastmess']['link']=forum_createItemLink($row2['lastmess']['idtop'],SECTION);
		  if($tm>A::$OPTIONS['rowsmes'])
		  $row2['lastmess']['link'].="?page=".floor($tm/A::$OPTIONS['rowsmes']);
		  $row2['lastmess']['owner']=A::$DB->getRowById($row2['lastmess']['idowner'],A::$AUTH->section);
		}
	    $row['subcategories'][]=$row2;
	  }
	  A::$DB->free();
	  $categories[]=$row;
    }
    A::$DB->free();

	$this->Assign("categories",$categories);
	$this->AddNavigation(SECTION_NAME);
  }

  function getPager($idtop,$rowsmes,$link)
  {
    $pager=array();
	$rcount=A::$DB->getOne("SELECT COUNT(*) FROM ".SECTION."_messages WHERE idtop=$idtop");
	$pages=ceil($rcount/$rowsmes);
	if($pages>1)
    { for($i=0;$i<$pages;$i++)
	  if($i==0)
	  $pager[]="<a href=\"$link\">".($i+1)."</a>";
	  elseif($i<10)
	  $pager[]="<a href=\"$link?page=$i\">".($i+1)."</a>";
	  else
	  break;
	  if($pages>10)
	  { if($pages>11)
	    $pager[]="...";
	    $i=$pages-1;
	    $pager[]="<a href=\"$link?page=$i\">".($i+1)."</a>";
	  }
	}
	return implode(" ",$pager);
  }

  function CategoryPage()
  {
	if($this->category['level']==0)
	A::goUrl(getSectionLink(SECTION));

	$this->category['link']=forum_createCategoryLink($this->idcat,SECTION);
	$this->Assign("category",$this->category);

	$newclosetopic = getAccess("newclosetopic") || getAccess("cat{$this->idcat}_newclosetopic");
	$moderation = getAccess("moderation",SECTION,false) || getAccess("cat{$this->idcat}_moderation",SECTION,false);
    $this->Assign('newclosetopic_access',$newclosetopic_access = A::$AUTH->isLogin() && ($newclosetopic || $moderation));

	if($newclosetopic_access)
	{ $newtopiclink=$this->category['link']."addtopic.html";
	  $this->Assign("newtopiclink",$newtopiclink);
	}

	$topics=array();
	$pager = new A_Pager(A::$OPTIONS['rowstop']);
    $pager->query("
	SELECT t.*,MAX(m.date) AS lastdate
	FROM ".SECTION."_topics AS t
	LEFT JOIN ".SECTION."_messages AS m ON m.idtop=t.id
	WHERE t.idcat={$this->idcat}
	GROUP BY m.idtop
	ORDER BY lastdate DESC");
    while($row=$pager->fetchRow())
    { $row['link']=forum_createItemLink($row['id'],SECTION);
	  $row['pager']=$this->getPager($row['id'],A::$OPTIONS['rowsmes'],$row['link']);
	  $row['messages']=A::$DB->getOne("SELECT COUNT(*) FROM ".SECTION."_messages WHERE idtop=".$row['id']);
	  if($row['messages']>A::$OPTIONS['rowsmes'])
	  $row['lastlink']=$row['link']."?page=".floor($row['messages']/A::$OPTIONS['rowsmes']);
	  $row['owner']=A::$DB->getRowById($row['idowner'],A::$AUTH->section);
	  if($row['lastmess']=A::$DB->getRow("SELECT * FROM ".SECTION."_messages WHERE idtop=".$row['id']." ORDER BY date DESC LIMIT 0,1"))
	  $row['lastmess']['owner']=A::$DB->getRowById($row['lastmess']['idowner'],A::$AUTH->section);
	  if(($row['idowner']==A::$AUTH->id && $newclosetopic) || $moderation)
	  { if($row['active']=='Y')
	    $row['closelink']=$this->category['link']."?action=closetopic&id=".$row['id']."&authcode=".A::$AUTH->authcode.(!empty($_GET['page'])?"&page=".$_GET['page']:"");
	  }
	  if($moderation)
	  $row['deletelink']=$this->category['link']."?action=deltopic&id=".$row['id']."&authcode=".A::$AUTH->authcode.(!empty($_GET['page'])?"&page=".$_GET['page']:"");
	  $topics[]=$row;
    }
    $pager->free();

	$this->Assign("topics",$topics);
	$this->Assign("topics_pager",$pager);

	$this->AddNavigation(SECTION_NAME,getSectionLink(SECTION));

	$this->title=$this->category['name'].(!empty($this->title)?" - ".$this->title:"");
  }

  function TopicPage()
  {
    $views=A_Session::get(SECTION."_views",array());
    if(!in_array($this->idtop,$views))
    { A::$DB->execute("UPDATE ".SECTION."_topics SET views=views+1 WHERE id=".$this->idtop);
      $views[]=$this->idtop;
    }
	A_Session::set(SECTION."_views",$views);

	$this->category['link']=forum_createCategoryLink($this->idcat,SECTION);
	$this->Assign("category",$this->category);

	$newmessage = getAccess("newmessage") || getAccess("cat{$this->idcat}_newmessage");
	$newclosetopic = getAccess("newclosetopic") || getAccess("cat{$this->idcat}_newclosetopic");
	$moderation = getAccess("moderation",SECTION,false) || getAccess("cat{$this->idcat}_moderation",SECTION,false);
	$usefiles = A::$OPTIONS['usefiles']?$moderation || getAccess("download"):false;
	$this->Assign('newclosetopic_access',$newclosetopic_access = A::$AUTH->isLogin() && ($newclosetopic || $moderation));
	$this->Assign('newmessage_access',A::$AUTH->isLogin() && ($newmessage || $moderation));
	$this->Assign("usefiles",$usefiles);

	if($newclosetopic_access)
	{ $newtopiclink=$this->category['link']."addtopic.html";
	  $this->Assign("newtopiclink",$newtopiclink);
	}

	$this->topic['link']=$this->category['link'].$this->idtop.".html";
	$this->Assign("topic",$this->topic);

	$lastpost=A::$DB->getOne("SELECT MAX(date) FROM ".SECTION."_messages WHERE idtop=".$this->idtop);
	$countpost=A::$DB->getOne("SELECT COUNT(*) FROM ".SECTION."_messages WHERE idtop=".$this->idtop);

	$messages=array();
	$pager = new A_Pager(A::$OPTIONS['rowsmes']);
    $pager->query("SELECT * FROM ".SECTION."_messages WHERE idtop={$this->idtop} ORDER BY date");
    while($row=$pager->fetchRow())
    { if($row['owner']=A::$DB->getRowById($row['idowner'],A::$AUTH->section))
	  { $row['owner']['mcount']=A::$DB->getOne("SELECT COUNT(*) FROM ".SECTION."_messages WHERE idowner=".$row['idowner']);
	    $row['owner']['link']=getSectionLink(A::$AUTH->section).$row['owner']['login'].'/';
	  }
	  if((A::$AUTH->isLogin() && $this->topic['active']=='Y' && $newmessage) || $moderation)
	  { $row['quotelink']=$this->topic['link']."?action=quote&id=".$row['id']."&authcode=".A::$AUTH->authcode.(!empty($_GET['page'])?"&page=".$_GET['page']:"");
	    if(($row['idowner']==A::$AUTH->id && $row['date']==$lastpost) || $moderation)
	    $row['editlink']=$this->topic['link']."?action=editmessage&id=".$row['id']."&authcode=".A::$AUTH->authcode.(!empty($_GET['page'])?"&page=".$_GET['page']:"");
	    if((($row['idowner']==A::$AUTH->id && $row['date']==$lastpost) || $moderation) && $countpost>1)
		$row['deletelink']=$this->topic['link']."?action=delmessage&id=".$row['id']."&authcode=".A::$AUTH->authcode.(!empty($_GET['page'])?"&page=".$_GET['page']:"");
	  }
	  $messages[]=$row;
    }
	$this->Assign("messages",$messages);
	$this->Assign("messages_pager",$pager);
	$preview=A::$AUTH->isLogin() && !empty($_REQUEST['action']) && $_REQUEST['action']=='preview';
	$this->Assign("preview",$preview);
	$usersmail=!empty($this->topic['usersmail'])?unserialize($this->topic['usersmail']):array();

	$form=$_REQUEST;
	if($preview)
	$_REQUEST['idedit']=$_REQUEST['id'];
	if(!empty($_REQUEST['idedit']))
	{ if($mrow=A::$DB->getRowById($_REQUEST['idedit'],SECTION."_messages"))
	  { $form['idedit']=$mrow['id'];
	    $form['owner']=A::$DB->getRowById($mrow['idowner'],A::$AUTH->section);
	    $form['owner']['mcount']=A::$DB->getOne("SELECT COUNT(*) FROM ".SECTION."_messages WHERE idowner=".$mrow['idowner']);
	    $form['date']=$mrow['date'];
	  }
	}
	if(!isset($form['owner']))
	{ $form['owner']=A::$AUTH->data;
	  $form['owner']['mcount']=A::$DB->getOne("SELECT COUNT(*) FROM ".SECTION."_messages WHERE idowner=".A::$AUTH->id)+1;
	}
	if(empty($form['date']))
	$form['date']=time();
	$form['message']=!empty($form['bbcode'])?parse_bbcode($form['bbcode']):"";
	$form['tomail']=isset($_REQUEST['tomail']) || in_array(A::$AUTH->id,$usersmail)?'Y':'N';
	$this->Assign("form",$form);

	if($newmessage || $moderation)
	{ $tomail=array(
	  'active'=>$form['tomail']=='Y',
	  'link'=>$this->topic['link']."?action=tomail&authcode=".A::$AUTH->authcode.(!empty($_GET['page'])?"&page=".$_GET['page']:""));
	  $this->Assign("tomail",$tomail);
	}

	$this->AddNavigation(SECTION_NAME,getSectionLink(SECTION));
    $this->AddNavigation($this->category['name'],$this->category['link']);

    $this->title=$this->topic['name'].(!empty($this->title)?" - ".$this->title:"");
  }

  function AddTopicPage()
  {
	$this->category['link']=forum_createCategoryLink($this->idcat,SECTION);
	$this->Assign("category",$this->category);

	$newclosetopic = getAccess("newclosetopic") || getAccess("cat{$this->idcat}_newclosetopic");
	$moderation = getAccess("moderation",SECTION,false) || getAccess("cat{$this->idcat}_moderation",SECTION,false);
	$this->Assign('newclosetopic_access',A::$AUTH->isLogin() && ($newclosetopic || $moderation));

	$usefiles = A::$OPTIONS['usefiles']?$moderation || getAccess("download"):false;
    $this->Assign("usefiles",$usefiles);

	$this->Assign("preview",A::$AUTH->isLogin() && !empty($_REQUEST['action']) && $_REQUEST['action']=='preview');

	$form=$_REQUEST;
	$form['message']=!empty($form['bbcode'])?parse_bbcode($form['bbcode']):"";
	$form['owner']=A::$AUTH->data;
	$form['owner']['mcount']=A::$DB->getOne("SELECT COUNT(*) FROM ".SECTION."_messages WHERE idowner=".A::$AUTH->id)+1;
	$form['date']=time();
	$form['tomail']=isset($_REQUEST['tomail'])?'Y':'N';
	$this->Assign("form",$form);

    $this->AddNavigation(SECTION_NAME,getSectionLink(SECTION));
    $this->AddNavigation($this->category['name'],$this->category['link']);
  }
}

A::$MAINFRAME = new ForumModule;